"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var thunkUnwrap_1 = __importDefault(require("./thunkUnwrap"));
describe("Thunk unwrap middleware", function () {
    it("Should dispatch correctly", function () {
        // Setup
        var dispatched = [];
        var middleware = thunkUnwrap_1.default();
        var dispatcher = middleware({
            dispatch: function (a) { return a; },
            getState: function () { return ({}); }
        })(function (a) {
            dispatched.push(a);
            return a;
        });
        // When
        dispatcher({ payload: function () { } });
        // Then
        expect(dispatched).toHaveLength(2);
        expect(dispatched[0]).toBeInstanceOf(Object);
        expect(dispatched[1]).toBeInstanceOf(Function);
    });
});
