"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var querystring_1 = __importDefault(require("querystring"));
var utils_1 = require("../utils");
/** This repository allows synchronization of data with current URL. */
function createURLDataSyncRepository(_a, client) {
    var history = _a.history, location = _a.location;
    function urlParams(additionalQuery) {
        return __assign({}, additionalQuery, querystring_1.default.parse(location.search.slice(1)));
    }
    var urlDataSync = {
        get: function (additionalQuery) {
            return client.get(location.pathname, { params: urlParams(additionalQuery) });
        },
        update: function (newData) {
            return client.patch(location.pathname, newData, { params: urlParams() });
        },
        updateURLQuery: function (query) {
            var newQueryMap = Object.entries(query)
                .filter(function (_a) {
                var value = _a[1];
                return !!value && !!utils_1.toArray(value).length;
            })
                .reduce(function (acc, _a) {
                var _b;
                var key = _a[0], value = _a[1];
                return (__assign({}, acc, (_b = {}, _b[key] = value, _b)));
            }, {});
            var merged = querystring_1.default.stringify(newQueryMap);
            history.replaceState({}, "", !!merged ? "?" + merged : "");
        },
        getURLQuery: function () {
            var search = location.search;
            return querystring_1.default.parse(search.slice(1));
        }
    };
    return urlDataSync;
}
exports.createURLDataSyncRepository = createURLDataSyncRepository;
